STACK:		DC.L	$1000
RESET:		DC.L	$100
DIS_BASE:	EQU		$600000
TEXT_ROW:	EQU		80
TEXT_COL:	EQU		30
STRING:		DC.B	'Hello World!',0

										; 80 * 30 ASCII text display device
										; Display device base address = $600000
										; Offset 0 = Control byte (Set MSB to reset/clear display)
										; Offset 2 = Set X Pos (0-79)
										; Offset 3 = Set Y Pos (0-29)
										; Offset 4 = Set character at pos
			ORG		$100
			MOVE.B	#$80,DIS_BASE		; Clear screen
			MOVE.B	#0,D0				; D0 = X Pos
			MOVE.B	#0,D1				; D1 = Y Pos
LOOP:		LEA		STRING,A0			; A0 = String
			JSR		DRAW_STR
			BRA		LOOP

DRAW_STR:	LEA		DIS_BASE,A1
DRAW_CHR:	CMPI.B	#0,(A0)
			BEQ		END_STR
			MOVE.B	(A0),4(A1)
			ADDQ	#1,A0
ADD_ROW:	ADDQ	#1,D0
			CMP.B	#TEXT_ROW,D0
			BNE		SET_POS
ADD_COL:	MOVE.B	#0,D0
			ADDQ	#1,D1
			CMP.B	#TEXT_COL,D1
			BNE		SET_POS
			MOVE.B	#0,D1
SET_POS:	MOVE.B	D0,2(A1)
			MOVE.B	D1,3(A1)
			BRA		DRAW_CHR
END_STR:	RTS